Summary:     An advanced, incredibly configurable and secure FTP daemon
Name:        proftpd
Version:     1.2.10
Release:     3.pp
License:     GPL
Group:       System Environment/Daemons
Source0:     ftp://ftp.%{name}.org/distrib/source/%{name}-%{version}.tar.bz2
Source1:     %{name}.conf
Source2:     %{name}.logrotate
Source3:     %{name}.sysconfig
Source4:     http://www.castaglia.org/%{name}/modules/%{name}-mod-ban-0.4.5.tar.gz
Source5:     http://www.castaglia.org/%{name}/modules/%{name}-mod-case-0.2.tar.gz
Source6:     http://www.castaglia.org/%{name}/modules/%{name}-mod-counter-0.2.tar.gz
Source7:     http://www.castaglia.org/proftpd/modules/proftpd-mod-delay-0.4.tar.gz
Source8:     http://www.castaglia.org/proftpd/modules/proftpd-mod-diskuse-0.8.2.tar.gz
Source9:     http://www.castaglia.org/proftpd/modules/proftpd-mod-gzipfs-0.9rc4.tar.gz
Source10:    http://www.castaglia.org/proftpd/modules/proftpd-mod-load-1.0.1.tar.gz
Source11:    http://www.castaglia.org/proftpd/modules/proftpd-mod-md5fs-0.9rc9.tar.gz
Source12:    http://www.castaglia.org/proftpd/modules/proftpd-mod-msg-0.4.1.tar.gz
Source13:    http://www.castaglia.org/proftpd/modules/proftpd-mod-rename-0.14.tar.gz
Source14:    http://www.castaglia.org/proftpd/modules/proftpd-mod-shaper-0.5.5.tar.gz
Source15:    http://www.castaglia.org/proftpd/modules/proftpd-mod-time-2.2.1.tar.gz
Source16:    http://www.castaglia.org/proftpd/modules/proftpd-mod-wrap-2.0.2.tar.gz
Source17:    http://www.castaglia.org/proftpd/modules/proftpd-mod-xfer-mmap-0.2.tar.gz
Source18:    http://horde.net/~jwm/software/mod_ldap/mod_ldap-2.8.14.tar.gz
Patch0:      proftpd-mod_ldap-compile.patch
URL:         http://www.%{name}.org/
Buildroot:   /var/tmp/%{name}-root
Vendor:      The ProFTPD Project
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Requires:    pam openssl097 openldap22 ncurses perl zlib
Provides:    %{name}.pp
Prereq:      /bin/bash /sbin/chkconfig
BuildPrereq: gcc >= 2.96 /bin/mkdir /usr/bin/make /usr/bin/install
BuildPrereq: pam-devel openssl097-devel openldap22-devel ncurses-devel
BuildPrereq: zlib-devel
ExclusiveOS: linux


%description
ProFTPD is a proven, high-performance, scalable FTP server written
from scratch, with a focus toward simplicity, security, and ease of
configuration. Naturally, ProFTPD powers some of the largest sites
on the Internet. It features a very Apache-like configuration syntax,
modules, and a highly customizable server infrastructure, including
support for multiple 'virtual' FTP servers, anonymous FTP, and
permission-based directory visibility.


%prep
%setup -q -a4 -a5 -a6 -a7 -a8 -a9 -a10 -a11 -a12 -a13 -a14 -a15 -a16 -a17 -a18
%patch0 -p1
for mods in diskuse load wrap*; do
   pushd mod_${mods}
   ./configure
   popd
done
cp -f contrib/mod_*.html doc/modules
cp -f mod_*/*.[ch] contrib
cp -f mod_*/*.html doc/modules
cp -f mod_ldap*/README README.LDAP
cp -f mod_ldap*/*-ldif doc/modules
cp -f mod_ldap*/rfc* doc/rfc
cp contrib/dist/rpm/xinetd doc/proftpd.xinetd


%build
export CFLAGS="$RPM_OPT_FLAGS -I/usr/kerberos/include"
./configure \
	--prefix=/usr            \
	--sysconfdir=/etc        \
	--localstatedir=/var/run \
	--mandir=/usr/share/man  \
	--enable-ctrls           \
	--with-includes=contrib  \
	--with-includes=/usr/kerberos/include \
	--with-modules=mod_tls:mod_ldap:mod_ctrls_admin:mod_ifsession:mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_ratio:mod_readme:mod_rewrite:mod_site_misc:mod_wrap:mod_wrap_file:mod_ban:mod_case:mod_counter:mod_delay:mod_diskuse:mod_gzipfs:mod_load:mod_md5fs:mod_msg:mod_rename:mod_shaper:mod_time:mod_xfer_mmap
make all


%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/var/lib/proftpd
make \
	prefix=$RPM_BUILD_ROOT/usr             \
	exec_prefix=$RPM_BUILD_ROOT/usr        \
	sysconfdir=$RPM_BUILD_ROOT/etc         \
	mandir=$RPM_BUILD_ROOT/usr/share/man   \
	localstatedir=$RPM_BUILD_ROOT/var/run  \
	rundir=$RPM_BUILD_ROOT/var/run/proftpd \
	INSTALL_USER=`id -un`                  \
	INSTALL_GROUP=`id -gn`                 \
	install
install -m 0755 contrib/dist/rpm/proftpd.init.d $RPM_BUILD_ROOT/etc/rc.d/init.d/proftpd
install -m 0640 %{SOURCE1} $RPM_BUILD_ROOT/etc/proftpd.conf.sample
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/proftpd
install -m 0644 %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/proftpd
install -m 0644 contrib/dist/rpm/ftp.pamd $RPM_BUILD_ROOT/etc/pam.d/ftp
# Contrib
install -m 0755 contrib/ftpasswd contrib/ftpquota $RPM_BUILD_ROOT/usr/bin
install -m 0755 contrib/xferstats.holger-preiss $RPM_BUILD_ROOT/usr/bin/xferstats


%clean
rm -rf ${RPM_BUILD_ROOT}


%pre
if [ ! -f /etc/ftpusers ]; then
   touch /etc/ftpusers
   IFS=":"
   while { read username nu nu gid nu; }; do
      if [ $gid -le 100 -a "$username" != "ftp" ]; then
         echo $username
      fi
   done < /etc/passwd > /etc/ftpusers
fi


%post
/sbin/chkconfig --add proftpd
/sbin/chkconfig proftpd on
if [ -s /etc/proftpd.conf ]; then
   if [ -f /var/lock/subsys/proftpd ]; then
      /etc/rc.d/init.d/proftpd restart
   fi
fi


%preun
if [ $1 = 0 ] ; then
   /sbin/chkconfig proftpd off
   /sbin/chkconfig --del proftpd
   if [ -f /var/lock/subsys/proftpd ]; then
      /etc/rc.d/init.d/proftpd stop
   fi
   if [ -d /var/run/proftpd ]; then
      rm -rf /var/run/proftpd/*
   fi
fi


%files
%defattr(-,root,root)
%doc COPYING CREDITS ChangeLog INSTALL NEWS README* RELEASE_NOTES
%doc contrib/README.* contrib/ft*.html doc/* sample-configurations
/etc/proftpd.conf.sample
%config(noreplace) /etc/logrotate.d/*
%config(noreplace) /etc/pam.d/*
%config(noreplace) /etc/sysconfig/*
/etc/rc.d/init.d/*
/usr/bin/*
/usr/sbin/*
/usr/share/man/man1/*
/usr/share/man/man5/*
/usr/share/man/man8/*
%dir %attr(750,root,root) /var/run/proftpd
%dir %attr(750,root,root) /var/lib/proftpd


%changelog
* Wed Nov 03 2004 peter.pramberger@member.fsf.org
- created

